import { Component, HTMLAttributes } from 'react';
import PropTypes from 'prop-types';
import { BreakpointMap } from '../responsive/Responsive';
export interface RowProps extends HTMLAttributes<HTMLDivElement> {
    gutter?: number | BreakpointMap;
    type?: 'flex';
    align?: 'top' | 'middle' | 'bottom';
    justify?: 'start' | 'end' | 'center' | 'space-around' | 'space-between';
    prefixCls?: string;
}
export default class Row extends Component<RowProps> {
    static displayName: string;
    static defaultProps: {
        gutter: number;
    };
    static propTypes: {
        type: PropTypes.Requireable<string>;
        align: PropTypes.Requireable<string>;
        justify: PropTypes.Requireable<string>;
        className: PropTypes.Requireable<string>;
        children: PropTypes.Requireable<PropTypes.ReactNodeLike>;
        gutter: PropTypes.Requireable<number | object>;
        prefixCls: PropTypes.Requireable<string>;
    };
    renderRow: ([gutter]: [(number | undefined)?]) => JSX.Element;
    render(): JSX.Element;
}
