import _extends from 'babel-runtime/helpers/extends';
import _defineProperty from 'babel-runtime/helpers/defineProperty';
import _objectWithoutProperties from 'babel-runtime/helpers/objectWithoutProperties';
import _slicedToArray from 'babel-runtime/helpers/slicedToArray';
import _classCallCheck from 'babel-runtime/helpers/classCallCheck';
import _createClass from 'babel-runtime/helpers/createClass';
import _possibleConstructorReturn from 'babel-runtime/helpers/possibleConstructorReturn';
import _inherits from 'babel-runtime/helpers/inherits';
import React, { Children, cloneElement, Component } from 'react';
import classNames from 'classnames';
import PropTypes from 'prop-types';
import Responsive from '../responsive/Responsive';
import { getPrefixCls } from '../configure';
var defaultGutter = 0;

var Row = function (_Component) {
    _inherits(Row, _Component);

    function Row() {
        _classCallCheck(this, Row);

        var _this = _possibleConstructorReturn(this, (Row.__proto__ || Object.getPrototypeOf(Row)).apply(this, arguments));

        _this.renderRow = function (_ref) {
            var _classNames;

            var _ref2 = _slicedToArray(_ref, 1),
                _ref2$ = _ref2[0],
                gutter = _ref2$ === undefined ? defaultGutter : _ref2$;

            var _this$props = _this.props,
                type = _this$props.type,
                justify = _this$props.justify,
                align = _this$props.align,
                className = _this$props.className,
                style = _this$props.style,
                children = _this$props.children,
                customizePrefixCls = _this$props.prefixCls,
                others = _objectWithoutProperties(_this$props, ['type', 'justify', 'align', 'className', 'style', 'children', 'prefixCls']);

            var prefixCls = getPrefixCls('row', customizePrefixCls);
            var classes = classNames((_classNames = {}, _defineProperty(_classNames, prefixCls, !type), _defineProperty(_classNames, prefixCls + '-' + type, type), _defineProperty(_classNames, prefixCls + '-' + type + '-' + justify, type && justify), _defineProperty(_classNames, prefixCls + '-' + type + '-' + align, type && align), _classNames), className);
            var rowStyle = gutter > 0 ? _extends({
                marginLeft: gutter / -2,
                marginRight: gutter / -2
            }, style) : style;
            var cols = Children.map(children, function (col) {
                if (!col) {
                    return null;
                }
                if (col.props && gutter > 0) {
                    return cloneElement(col, {
                        style: _extends({
                            paddingLeft: gutter / 2,
                            paddingRight: gutter / 2
                        }, col.props.style)
                    });
                }
                return col;
            });
            var otherProps = _extends({}, others);
            delete otherProps.gutter;
            return React.createElement(
                'div',
                _extends({}, otherProps, { className: classes, style: rowStyle }),
                cols
            );
        };
        return _this;
    }

    _createClass(Row, [{
        key: 'render',
        value: function render() {
            return React.createElement(
                Responsive,
                { items: [this.props.gutter] },
                this.renderRow
            );
        }
    }]);

    return Row;
}(Component);

export default Row;

Row.displayName = 'Row';
Row.defaultProps = {
    gutter: defaultGutter
};
Row.propTypes = {
    type: PropTypes.string,
    align: PropTypes.string,
    justify: PropTypes.string,
    className: PropTypes.string,
    children: PropTypes.node,
    gutter: PropTypes.oneOfType([PropTypes.object, PropTypes.number]),
    prefixCls: PropTypes.string
};