'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _slicedToArray2 = require('babel-runtime/helpers/slicedToArray');

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Responsive = require('../responsive/Responsive');

var _Responsive2 = _interopRequireDefault(_Responsive);

var _configure = require('../configure');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var defaultGutter = 0;

var Row = function (_Component) {
    (0, _inherits3['default'])(Row, _Component);

    function Row() {
        (0, _classCallCheck3['default'])(this, Row);

        var _this = (0, _possibleConstructorReturn3['default'])(this, (Row.__proto__ || Object.getPrototypeOf(Row)).apply(this, arguments));

        _this.renderRow = function (_ref) {
            var _classNames;

            var _ref2 = (0, _slicedToArray3['default'])(_ref, 1),
                _ref2$ = _ref2[0],
                gutter = _ref2$ === undefined ? defaultGutter : _ref2$;

            var _this$props = _this.props,
                type = _this$props.type,
                justify = _this$props.justify,
                align = _this$props.align,
                className = _this$props.className,
                style = _this$props.style,
                children = _this$props.children,
                customizePrefixCls = _this$props.prefixCls,
                others = (0, _objectWithoutProperties3['default'])(_this$props, ['type', 'justify', 'align', 'className', 'style', 'children', 'prefixCls']);

            var prefixCls = (0, _configure.getPrefixCls)('row', customizePrefixCls);
            var classes = (0, _classnames2['default'])((_classNames = {}, (0, _defineProperty3['default'])(_classNames, prefixCls, !type), (0, _defineProperty3['default'])(_classNames, prefixCls + '-' + type, type), (0, _defineProperty3['default'])(_classNames, prefixCls + '-' + type + '-' + justify, type && justify), (0, _defineProperty3['default'])(_classNames, prefixCls + '-' + type + '-' + align, type && align), _classNames), className);
            var rowStyle = gutter > 0 ? (0, _extends3['default'])({
                marginLeft: gutter / -2,
                marginRight: gutter / -2
            }, style) : style;
            var cols = _react.Children.map(children, function (col) {
                if (!col) {
                    return null;
                }
                if (col.props && gutter > 0) {
                    return (0, _react.cloneElement)(col, {
                        style: (0, _extends3['default'])({
                            paddingLeft: gutter / 2,
                            paddingRight: gutter / 2
                        }, col.props.style)
                    });
                }
                return col;
            });
            var otherProps = (0, _extends3['default'])({}, others);
            delete otherProps.gutter;
            return _react2['default'].createElement(
                'div',
                (0, _extends3['default'])({}, otherProps, { className: classes, style: rowStyle }),
                cols
            );
        };
        return _this;
    }

    (0, _createClass3['default'])(Row, [{
        key: 'render',
        value: function render() {
            return _react2['default'].createElement(
                _Responsive2['default'],
                { items: [this.props.gutter] },
                this.renderRow
            );
        }
    }]);
    return Row;
}(_react.Component);

exports['default'] = Row;

Row.displayName = 'Row';
Row.defaultProps = {
    gutter: defaultGutter
};
Row.propTypes = {
    type: _propTypes2['default'].string,
    align: _propTypes2['default'].string,
    justify: _propTypes2['default'].string,
    className: _propTypes2['default'].string,
    children: _propTypes2['default'].node,
    gutter: _propTypes2['default'].oneOfType([_propTypes2['default'].object, _propTypes2['default'].number]),
    prefixCls: _propTypes2['default'].string
};
module.exports = exports['default'];