import { PureComponent, ReactNode } from 'react';
import { Breakpoint } from './enum';
export declare type BreakpointMap = {
    [Breakpoint.xxl]?: string;
    [Breakpoint.xl]?: string;
    [Breakpoint.lg]?: string;
    [Breakpoint.md]?: string;
    [Breakpoint.sm]?: string;
    [Breakpoint.xs]?: string;
};
export declare type ChildrenFunction = (items: any[]) => ReactNode;
export interface ResponsiveProps {
    disabled?: boolean;
    items?: (any | BreakpointMap)[];
    children?: ReactNode | ChildrenFunction;
    onChange?: (items: any[]) => void;
}
export interface ResponsiveState {
    breakpoints: BreakpointMap;
}
export default class Responsive extends PureComponent<ResponsiveProps, ResponsiveState> {
    static displayName: string;
    state: {
        breakpoints: {};
    };
    isDisabled(props: any): boolean;
    componentDidMount(): void;
    componentDidUpdate(): void;
    componentWillReceiveProps(nextProps: any): void;
    componentWillUnmount(): void;
    register(): void;
    unregister(): void;
    processValue(value: any): any;
    getValues(): any[];
    render(): {} | null | undefined;
}
