'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends4 = require('babel-runtime/helpers/extends');

var _extends5 = _interopRequireDefault(_extends4);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _responsiveMap;

var _react = require('react');

var _isObject = require('lodash/isObject');

var _isObject2 = _interopRequireDefault(_isObject);

var _mobx = require('mobx');

var _mediaQueryListPolyfill = require('../_util/mediaQueryListPolyfill');

var _enum = require('./enum');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var enquire = void 0;
if (typeof window !== 'undefined') {
    window.matchMedia = window.matchMedia || _mediaQueryListPolyfill.matchMediaPolifill;
    enquire = require('enquire.js');
}
var responsiveMap = (_responsiveMap = {}, (0, _defineProperty3['default'])(_responsiveMap, _enum.Breakpoint.xxl, '(min-width: 1600px)'), (0, _defineProperty3['default'])(_responsiveMap, _enum.Breakpoint.xl, '(min-width: 1200px)'), (0, _defineProperty3['default'])(_responsiveMap, _enum.Breakpoint.lg, '(min-width: 992px)'), (0, _defineProperty3['default'])(_responsiveMap, _enum.Breakpoint.md, '(min-width: 768px)'), (0, _defineProperty3['default'])(_responsiveMap, _enum.Breakpoint.sm, '(min-width: 576px)'), (0, _defineProperty3['default'])(_responsiveMap, _enum.Breakpoint.xs, '(max-width: 575px)'), _responsiveMap);
var responsiveArray = Object.keys(responsiveMap);

var Responsive = function (_PureComponent) {
    (0, _inherits3['default'])(Responsive, _PureComponent);

    function Responsive() {
        (0, _classCallCheck3['default'])(this, Responsive);

        var _this = (0, _possibleConstructorReturn3['default'])(this, (Responsive.__proto__ || Object.getPrototypeOf(Responsive)).apply(this, arguments));

        _this.state = { breakpoints: {} };
        return _this;
    }

    (0, _createClass3['default'])(Responsive, [{
        key: 'isDisabled',
        value: function isDisabled(props) {
            var disabled = props.disabled,
                items = props.items;

            if (!disabled && items) {
                return !items.some(_isObject2['default']);
            }
            return true;
        }
    }, {
        key: 'componentDidMount',
        value: function componentDidMount() {
            if (!this.isDisabled(this.props)) {
                this.register();
            }
        }
    }, {
        key: 'componentDidUpdate',
        value: function componentDidUpdate() {
            var onChange = this.props.onChange;

            if (onChange) {
                onChange(this.getValues());
            }
        }
    }, {
        key: 'componentWillReceiveProps',
        value: function componentWillReceiveProps(nextProps) {
            if (this.isDisabled(this.props) && !this.isDisabled(nextProps)) {
                this.register();
            }
            if (!this.isDisabled(this.props) && this.isDisabled(nextProps)) {
                this.unregister();
            }
        }
    }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
            if (!this.isDisabled(this.props)) {
                this.unregister();
            }
        }
    }, {
        key: 'register',
        value: function register() {
            var _this2 = this;

            if (enquire) {
                responsiveArray.map(function (breakpoint) {
                    return enquire.register(responsiveMap[breakpoint], {
                        match: function match() {
                            _this2.setState(function (prevState) {
                                return {
                                    breakpoints: (0, _extends5['default'])({}, prevState.breakpoints, (0, _defineProperty3['default'])({}, breakpoint, true))
                                };
                            });
                        },
                        unmatch: function unmatch() {
                            _this2.setState(function (prevState) {
                                return {
                                    breakpoints: (0, _extends5['default'])({}, prevState.breakpoints, (0, _defineProperty3['default'])({}, breakpoint, false))
                                };
                            });
                        },
                        // Keep a empty destory to avoid triggering unmatch when unregister
                        destroy: function destroy() {}
                    });
                });
            }
        }
    }, {
        key: 'unregister',
        value: function unregister() {
            Object.keys(responsiveMap).map(function (breakpoint) {
                return enquire.unregister(responsiveMap[breakpoint]);
            });
        }
    }, {
        key: 'processValue',
        value: function processValue(value) {
            var breakpoints = this.state.breakpoints;

            if ((0, _mobx.isArrayLike)(value)) {
                return value.map(this.processValue, this);
            } else if ((0, _isObject2['default'])(value)) {
                for (var i = 0; i < responsiveArray.length; i++) {
                    var breakpoint = responsiveArray[i];
                    if (breakpoints[breakpoint] && value[breakpoint] !== void 0) {
                        return value[breakpoint];
                    }
                }
                return void 0;
            }
            return value;
        }
    }, {
        key: 'getValues',
        value: function getValues() {
            var items = this.props.items;

            if (items) {
                return items.map(this.processValue, this);
            }
            return [];
        }
    }, {
        key: 'render',
        value: function render() {
            var children = this.props.children;

            if (typeof children === 'function') {
                return children(this.getValues());
            }
            return children;
        }
    }]);
    return Responsive;
}(_react.PureComponent);

exports['default'] = Responsive;

Responsive.displayName = 'Responsive';
module.exports = exports['default'];