import _slicedToArray from 'babel-runtime/helpers/slicedToArray';
import isObject from 'lodash/isObject';
import isNil from 'lodash/isNil';
import { isArrayLike } from 'mobx';
export function toRangeValue(value, range) {
    if (isArrayLike(range)) {
        if (isObject(value)) {
            var _range = _slicedToArray(range, 2),
                start = _range[0],
                end = _range[1];

            return [value[start], value[end]];
        }
    } else if (isArrayLike(value)) {
        return value.slice(0, 2);
    }
    return [void 0, void 0];
}
export function toMultipleValue(value, range) {
    if (!isNil(value)) {
        var multipleValue = isArrayLike(value) ? value.slice() : [value];
        if (range) {
            return multipleValue.map(function (item) {
                return toRangeValue(item, range);
            });
        }
        return multipleValue;
    }
    return [];
}