import _regeneratorRuntime from 'babel-runtime/regenerator';
import _extends from 'babel-runtime/helpers/extends';
import _asyncToGenerator from 'babel-runtime/helpers/asyncToGenerator';
import _classCallCheck from 'babel-runtime/helpers/classCallCheck';
import _createClass from 'babel-runtime/helpers/createClass';
import _possibleConstructorReturn from 'babel-runtime/helpers/possibleConstructorReturn';
import _get from 'babel-runtime/helpers/get';
import _inherits from 'babel-runtime/helpers/inherits';
import * as tslib_1 from "tslib";
import React from 'react';
import { observer } from 'mobx-react';
import { action, observable } from 'mobx';
import { getConfig } from '../../../es/configure';
import { TextField } from '../text-field/TextField';
import Icon from '../icon';
import { open } from '../modal-container/ModalContainer';
import IntlList from './IntlList';
import localeContext, { $l } from '../locale-context';
import autobind from '../_util/autobind';
import KeyCode from '../../../es/_util/KeyCode';
import { stopEvent } from '../_util/EventManager';
import Progress from '../progress';
import exception from '../_util/exception';
import message from '../message';
var IntlField = function (_TextField) {
    _inherits(IntlField, _TextField);

    function IntlField() {
        var _this2 = this;

        _classCallCheck(this, IntlField);

        var _this = _possibleConstructorReturn(this, (IntlField.__proto__ || Object.getPrototypeOf(IntlField)).apply(this, arguments));

        _this.openModal = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee() {
            var modalProps, record, lang, name;
            return _regeneratorRuntime.wrap(function _callee$(_context) {
                while (1) {
                    switch (_context.prev = _context.next) {
                        case 0:
                            if (_this.modal) {
                                _context.next = 19;
                                break;
                            }

                            modalProps = _this.props.modalProps;
                            record = _this.record, lang = _this.lang, name = _this.name;

                            if (!record) {
                                _context.next = 17;
                                break;
                            }

                            _this.setLoading(true);
                            _context.prev = 5;
                            _context.next = 8;
                            return record.tls();

                        case 8:
                            _context.next = 14;
                            break;

                        case 10:
                            _context.prev = 10;
                            _context.t0 = _context['catch'](5);

                            message.error(exception(_context.t0));
                            return _context.abrupt('return');

                        case 14:
                            _context.prev = 14;

                            _this.setLoading(false);
                            return _context.finish(14);

                        case 17:
                            _this.storeLocales();
                            _this.modal = open(_extends({
                                title: $l('IntlField', 'modal_title'),
                                children: React.createElement(IntlList, { record: record, name: name, lang: lang }),
                                onClose: _this.handleIntlListClose,
                                onOk: _this.handleIntlListOk,
                                onCancel: _this.handleIntlListCancel,
                                destroyOnClose: true
                            }, modalProps));

                        case 19:
                        case 'end':
                            return _context.stop();
                    }
                }
            }, _callee, _this2, [[5, 10, 14, 17]]);
        }));
        _this.handleIntlListClose = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee2() {
            return _regeneratorRuntime.wrap(function _callee2$(_context2) {
                while (1) {
                    switch (_context2.prev = _context2.next) {
                        case 0:
                            delete _this.modal;
                            _this.focus();

                        case 2:
                        case 'end':
                            return _context2.stop();
                    }
                }
            }, _callee2, _this2);
        }));
        return _this;
    }

    _createClass(IntlField, [{
        key: 'setLoading',
        value: function setLoading(loading) {
            this.loading = loading;
        }
    }, {
        key: 'handleIntlListOk',
        value: function () {
            var _ref3 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee3() {
                var supports, languages, record, name, field, tlsKey;
                return _regeneratorRuntime.wrap(function _callee3$(_context3) {
                    while (1) {
                        switch (_context3.prev = _context3.next) {
                            case 0:
                                supports = localeContext.supports;
                                languages = Object.keys(supports);
                                record = this.record, name = this.name, field = this.field;

                                if (!(record && field)) {
                                    _context3.next = 9;
                                    break;
                                }

                                tlsKey = getConfig('tlsKey');
                                _context3.next = 7;
                                return Promise.all(languages.map(function (language) {
                                    var intlField = record.getField(tlsKey + '.' + name + '.' + language);
                                    return intlField ? intlField.checkValidity() : true;
                                }));

                            case 7:
                                _context3.t0 = Boolean;
                                return _context3.abrupt('return', _context3.sent.every(_context3.t0));

                            case 9:
                            case 'end':
                                return _context3.stop();
                        }
                    }
                }, _callee3, this);
            }));

            function handleIntlListOk() {
                return _ref3.apply(this, arguments);
            }

            return handleIntlListOk;
        }()
    }, {
        key: 'handleIntlListCancel',
        value: function () {
            var _ref4 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee4() {
                var name, record, tlsKey;
                return _regeneratorRuntime.wrap(function _callee4$(_context4) {
                    while (1) {
                        switch (_context4.prev = _context4.next) {
                            case 0:
                                name = this.name, record = this.record;

                                if (record) {
                                    tlsKey = getConfig('tlsKey');

                                    record.set(tlsKey + '.' + name, this.locales);
                                }

                            case 2:
                            case 'end':
                                return _context4.stop();
                        }
                    }
                }, _callee4, this);
            }));

            function handleIntlListCancel() {
                return _ref4.apply(this, arguments);
            }

            return handleIntlListCancel;
        }()
    }, {
        key: 'handleKeyDown',
        value: function handleKeyDown(e) {
            if (e.keyCode === KeyCode.DOWN) {
                stopEvent(e);
                this.openModal();
            }
            _get(IntlField.prototype.__proto__ || Object.getPrototypeOf(IntlField.prototype), 'handleKeyDown', this).call(this, e);
        }
    }, {
        key: 'handleBlur',
        value: function handleBlur(e) {
            if (this.modal) {
                e.preventDefault();
            }
            _get(IntlField.prototype.__proto__ || Object.getPrototypeOf(IntlField.prototype), 'handleBlur', this).call(this, e);
        }
    }, {
        key: 'storeLocales',
        value: function storeLocales() {
            var name = this.name,
                record = this.record;

            if (record) {
                var tlsKey = getConfig('tlsKey');
                this.locales = _extends({}, record.get(tlsKey + '.' + name));
            }
        }
    }, {
        key: 'getSuffix',
        value: function getSuffix() {
            var suffix = this.props.suffix;

            return this.wrapperSuffix(this.loading ? React.createElement(Progress, { size: "small" /* small */, type: "loading" /* loading */ }) : suffix || React.createElement(Icon, { type: 'language' }), {
                onClick: this.isDisabled() || this.isReadOnly() ? void 0 : this.openModal
            });
        }
    }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
            if (this.modal) {
                this.modal.close();
            }
        }
    }]);

    return IntlField;
}(TextField);
IntlField.displayName = 'IntlField';
tslib_1.__decorate([observable], IntlField.prototype, "loading", void 0);
tslib_1.__decorate([action], IntlField.prototype, "setLoading", null);
tslib_1.__decorate([autobind], IntlField.prototype, "handleIntlListOk", null);
tslib_1.__decorate([autobind], IntlField.prototype, "handleIntlListCancel", null);
tslib_1.__decorate([autobind], IntlField.prototype, "handleKeyDown", null);
tslib_1.__decorate([autobind], IntlField.prototype, "handleBlur", null);
IntlField = tslib_1.__decorate([observer], IntlField);
export default IntlField;