'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _slicedToArray2 = require('babel-runtime/helpers/slicedToArray');

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

exports.toRangeValue = toRangeValue;
exports.toMultipleValue = toMultipleValue;

var _isObject = require('lodash/isObject');

var _isObject2 = _interopRequireDefault(_isObject);

var _isNil = require('lodash/isNil');

var _isNil2 = _interopRequireDefault(_isNil);

var _mobx = require('mobx');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function toRangeValue(value, range) {
    if ((0, _mobx.isArrayLike)(range)) {
        if ((0, _isObject2['default'])(value)) {
            var _range = (0, _slicedToArray3['default'])(range, 2),
                start = _range[0],
                end = _range[1];

            return [value[start], value[end]];
        }
    } else if ((0, _mobx.isArrayLike)(value)) {
        return value.slice(0, 2);
    }
    return [void 0, void 0];
}
function toMultipleValue(value, range) {
    if (!(0, _isNil2['default'])(value)) {
        var multipleValue = (0, _mobx.isArrayLike)(value) ? value.slice() : [value];
        if (range) {
            return multipleValue.map(function (item) {
                return toRangeValue(item, range);
            });
        }
        return multipleValue;
    }
    return [];
}