'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _get2 = require('babel-runtime/helpers/get');

var _get3 = _interopRequireDefault(_get2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _tslib = require('tslib');

var tslib_1 = _interopRequireWildcard(_tslib);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _mobxReact = require('mobx-react');

var _mobx = require('mobx');

var _configure = require('../../../lib/configure');

var _TextField2 = require('../text-field/TextField');

var _icon = require('../icon');

var _icon2 = _interopRequireDefault(_icon);

var _ModalContainer = require('../modal-container/ModalContainer');

var _IntlList = require('./IntlList');

var _IntlList2 = _interopRequireDefault(_IntlList);

var _localeContext = require('../locale-context');

var _localeContext2 = _interopRequireDefault(_localeContext);

var _autobind = require('../_util/autobind');

var _autobind2 = _interopRequireDefault(_autobind);

var _KeyCode = require('../../../lib/_util/KeyCode');

var _KeyCode2 = _interopRequireDefault(_KeyCode);

var _EventManager = require('../_util/EventManager');

var _progress = require('../progress');

var _progress2 = _interopRequireDefault(_progress);

var _exception = require('../_util/exception');

var _exception2 = _interopRequireDefault(_exception);

var _message = require('../message');

var _message2 = _interopRequireDefault(_message);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj['default'] = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var IntlField = function (_TextField) {
    (0, _inherits3['default'])(IntlField, _TextField);

    function IntlField() {
        var _this2 = this;

        (0, _classCallCheck3['default'])(this, IntlField);

        var _this = (0, _possibleConstructorReturn3['default'])(this, (IntlField.__proto__ || Object.getPrototypeOf(IntlField)).apply(this, arguments));

        _this.openModal = (0, _asyncToGenerator3['default'])( /*#__PURE__*/_regenerator2['default'].mark(function _callee() {
            var modalProps, record, lang, name;
            return _regenerator2['default'].wrap(function _callee$(_context) {
                while (1) {
                    switch (_context.prev = _context.next) {
                        case 0:
                            if (_this.modal) {
                                _context.next = 19;
                                break;
                            }

                            modalProps = _this.props.modalProps;
                            record = _this.record, lang = _this.lang, name = _this.name;

                            if (!record) {
                                _context.next = 17;
                                break;
                            }

                            _this.setLoading(true);
                            _context.prev = 5;
                            _context.next = 8;
                            return record.tls();

                        case 8:
                            _context.next = 14;
                            break;

                        case 10:
                            _context.prev = 10;
                            _context.t0 = _context['catch'](5);

                            _message2['default'].error((0, _exception2['default'])(_context.t0));
                            return _context.abrupt('return');

                        case 14:
                            _context.prev = 14;

                            _this.setLoading(false);
                            return _context.finish(14);

                        case 17:
                            _this.storeLocales();
                            _this.modal = (0, _ModalContainer.open)((0, _extends3['default'])({
                                title: (0, _localeContext.$l)('IntlField', 'modal_title'),
                                children: _react2['default'].createElement(_IntlList2['default'], { record: record, name: name, lang: lang }),
                                onClose: _this.handleIntlListClose,
                                onOk: _this.handleIntlListOk,
                                onCancel: _this.handleIntlListCancel,
                                destroyOnClose: true
                            }, modalProps));

                        case 19:
                        case 'end':
                            return _context.stop();
                    }
                }
            }, _callee, _this2, [[5, 10, 14, 17]]);
        }));
        _this.handleIntlListClose = (0, _asyncToGenerator3['default'])( /*#__PURE__*/_regenerator2['default'].mark(function _callee2() {
            return _regenerator2['default'].wrap(function _callee2$(_context2) {
                while (1) {
                    switch (_context2.prev = _context2.next) {
                        case 0:
                            delete _this.modal;
                            _this.focus();

                        case 2:
                        case 'end':
                            return _context2.stop();
                    }
                }
            }, _callee2, _this2);
        }));
        return _this;
    }

    (0, _createClass3['default'])(IntlField, [{
        key: 'setLoading',
        value: function setLoading(loading) {
            this.loading = loading;
        }
    }, {
        key: 'handleIntlListOk',
        value: function () {
            var _ref3 = (0, _asyncToGenerator3['default'])( /*#__PURE__*/_regenerator2['default'].mark(function _callee3() {
                var supports, languages, record, name, field, tlsKey;
                return _regenerator2['default'].wrap(function _callee3$(_context3) {
                    while (1) {
                        switch (_context3.prev = _context3.next) {
                            case 0:
                                supports = _localeContext2['default'].supports;
                                languages = Object.keys(supports);
                                record = this.record, name = this.name, field = this.field;

                                if (!(record && field)) {
                                    _context3.next = 9;
                                    break;
                                }

                                tlsKey = (0, _configure.getConfig)('tlsKey');
                                _context3.next = 7;
                                return Promise.all(languages.map(function (language) {
                                    var intlField = record.getField(tlsKey + '.' + name + '.' + language);
                                    return intlField ? intlField.checkValidity() : true;
                                }));

                            case 7:
                                _context3.t0 = Boolean;
                                return _context3.abrupt('return', _context3.sent.every(_context3.t0));

                            case 9:
                            case 'end':
                                return _context3.stop();
                        }
                    }
                }, _callee3, this);
            }));

            function handleIntlListOk() {
                return _ref3.apply(this, arguments);
            }

            return handleIntlListOk;
        }()
    }, {
        key: 'handleIntlListCancel',
        value: function () {
            var _ref4 = (0, _asyncToGenerator3['default'])( /*#__PURE__*/_regenerator2['default'].mark(function _callee4() {
                var name, record, tlsKey;
                return _regenerator2['default'].wrap(function _callee4$(_context4) {
                    while (1) {
                        switch (_context4.prev = _context4.next) {
                            case 0:
                                name = this.name, record = this.record;

                                if (record) {
                                    tlsKey = (0, _configure.getConfig)('tlsKey');

                                    record.set(tlsKey + '.' + name, this.locales);
                                }

                            case 2:
                            case 'end':
                                return _context4.stop();
                        }
                    }
                }, _callee4, this);
            }));

            function handleIntlListCancel() {
                return _ref4.apply(this, arguments);
            }

            return handleIntlListCancel;
        }()
    }, {
        key: 'handleKeyDown',
        value: function handleKeyDown(e) {
            if (e.keyCode === _KeyCode2['default'].DOWN) {
                (0, _EventManager.stopEvent)(e);
                this.openModal();
            }
            (0, _get3['default'])(IntlField.prototype.__proto__ || Object.getPrototypeOf(IntlField.prototype), 'handleKeyDown', this).call(this, e);
        }
    }, {
        key: 'handleBlur',
        value: function handleBlur(e) {
            if (this.modal) {
                e.preventDefault();
            }
            (0, _get3['default'])(IntlField.prototype.__proto__ || Object.getPrototypeOf(IntlField.prototype), 'handleBlur', this).call(this, e);
        }
    }, {
        key: 'storeLocales',
        value: function storeLocales() {
            var name = this.name,
                record = this.record;

            if (record) {
                var tlsKey = (0, _configure.getConfig)('tlsKey');
                this.locales = (0, _extends3['default'])({}, record.get(tlsKey + '.' + name));
            }
        }
    }, {
        key: 'getSuffix',
        value: function getSuffix() {
            var suffix = this.props.suffix;

            return this.wrapperSuffix(this.loading ? _react2['default'].createElement(_progress2['default'], { size: "small" /* small */, type: "loading" /* loading */ }) : suffix || _react2['default'].createElement(_icon2['default'], { type: 'language' }), {
                onClick: this.isDisabled() || this.isReadOnly() ? void 0 : this.openModal
            });
        }
    }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
            if (this.modal) {
                this.modal.close();
            }
        }
    }]);
    return IntlField;
}(_TextField2.TextField);
IntlField.displayName = 'IntlField';
tslib_1.__decorate([_mobx.observable], IntlField.prototype, "loading", void 0);
tslib_1.__decorate([_mobx.action], IntlField.prototype, "setLoading", null);
tslib_1.__decorate([_autobind2['default']], IntlField.prototype, "handleIntlListOk", null);
tslib_1.__decorate([_autobind2['default']], IntlField.prototype, "handleIntlListCancel", null);
tslib_1.__decorate([_autobind2['default']], IntlField.prototype, "handleKeyDown", null);
tslib_1.__decorate([_autobind2['default']], IntlField.prototype, "handleBlur", null);
IntlField = tslib_1.__decorate([_mobxReact.observer], IntlField);
exports['default'] = IntlField;
module.exports = exports['default'];