'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _get2 = require('babel-runtime/helpers/get');

var _get3 = _interopRequireDefault(_get2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _tslib = require('tslib');

var tslib_1 = _interopRequireWildcard(_tslib);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _mobxReact = require('mobx-react');

var _mobx = require('mobx');

var _omit = require('lodash/omit');

var _omit2 = _interopRequireDefault(_omit);

var _isNil = require('lodash/isNil');

var _isNil2 = _interopRequireDefault(_isNil);

var _FormField2 = require('../field/FormField');

var _autobind = require('../_util/autobind');

var _autobind2 = _interopRequireDefault(_autobind);

var _processFieldValue = require('../_util/processFieldValue');

var _processFieldValue2 = _interopRequireDefault(_processFieldValue);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj['default'] = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var Output = function (_FormField) {
    (0, _inherits3['default'])(Output, _FormField);

    function Output() {
        (0, _classCallCheck3['default'])(this, Output);
        return (0, _possibleConstructorReturn3['default'])(this, (Output.__proto__ || Object.getPrototypeOf(Output)).apply(this, arguments));
    }

    (0, _createClass3['default'])(Output, [{
        key: 'handleChange',
        value: function handleChange() {}
    }, {
        key: 'getOtherProps',
        value: function getOtherProps() {
            return (0, _omit2['default'])((0, _get3['default'])(Output.prototype.__proto__ || Object.getPrototypeOf(Output.prototype), 'getOtherProps', this).call(this), ['name']);
        }
    }, {
        key: 'getText',
        value: function getText() {
            return this.processRenderer(this.getValue());
        }
    }, {
        key: 'getValueKey',
        value: function getValueKey(value) {
            if ((0, _mobx.isArrayLike)(value)) {
                return value.map(this.getValueKey, this).join(',');
            }
            return this.processValue(value);
        }
    }, {
        key: 'processValue',
        value: function processValue(value) {
            if (!(0, _isNil2['default'])(value)) {
                value = (0, _get3['default'])(Output.prototype.__proto__ || Object.getPrototypeOf(Output.prototype), 'processValue', this).call(this, value);
                var field = this.field,
                    lang = this.lang;

                if (field) {
                    return (0, _processFieldValue2['default'])(value, field, lang, true);
                }
            }
            return value;
        }
    }, {
        key: 'getRenderedValue',
        value: function getRenderedValue() {
            var multiple = this.multiple,
                range = this.range;

            if (multiple) {
                return this.renderMultipleValues(true);
            } else if (range) {
                return this.renderRangeValue(true);
            }
            return this.getText();
        }
    }, {
        key: 'renderWrapper',
        value: function renderWrapper() {
            return _react2['default'].createElement(
                'span',
                this.getMergedProps(),
                this.getRenderedValue()
            );
        }
    }, {
        key: 'editable',
        get: function get() {
            return false;
        }
    }]);
    return Output;
}(_FormField2.FormField);
Output.displayName = 'Output';
Output.defaultProps = (0, _extends3['default'])({}, _FormField2.FormField.defaultProps, {
    suffixCls: 'output'
});
tslib_1.__decorate([_mobx.computed], Output.prototype, "editable", null);
tslib_1.__decorate([_autobind2['default']], Output.prototype, "handleChange", null);
Output = tslib_1.__decorate([_mobxReact.observer], Output);
exports['default'] = Output;
module.exports = exports['default'];